//----------------------------------------------------------------------------
// Parser.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Parser.pas
//----------------------------------------------------------------------------
#ifndef ParserHPP
#define ParserHPP
//----------------------------------------------------------------------------
#include <Dialogs.hpp>
#include <AdvGrid.hpp>
#include <Windows.hpp>
#include <Grids.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <System.hpp>
namespace Parser
{
//-- type declarations -------------------------------------------------------
enum TokenType { Delimiter, Non, variable, Digit, endExpr, Error, Func };

struct TokenRec;
typedef TokenRec *TokenPtr;

struct TokenRec
{
	TokenRec *Next;
	Byte Start;
	Byte Close;
} ;

typedef void __fastcall (__closure *TIsCustomFunction)(System::TObject* sender,  System::AnsiString &
	func, bool &match);

typedef void __fastcall (__closure *TCalcCustomFunction)(System::TObject* sender,  System::AnsiString &
	func, double &param);

class __declspec(delphiclass) TGridFormula;
class __declspec(pascalimplementation) TGridFormula : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	double V[10];
	Byte i;
	Byte varlen;
	System::AnsiString fExpression;
	int fCol;
	int fRow;
	int fErrorPosition;
	Grids::TStringGrid* fStringGrid;
	TIsCustomFunction fIsCustomFunction;
	TCalcCustomFunction fCalcCustomFunction;
	System::AnsiString __fastcall ReadWord(void);
	double __fastcall ReadNumber(void);
	void __fastcall SkipBlanks(void);
	TokenType __fastcall GetToken(void);
	bool __fastcall MatchFunc( System::AnsiString Match, double &Res, TokenType &n);
	bool __fastcall MatchToken( System::AnsiString Match);
	bool __fastcall doPI(double &r);
	bool __fastcall doE(double &r);
	bool __fastcall doCol(double &r);
	bool __fastcall doRow(double &r);
	bool __fastcall DoNow(double &r);
	bool __fastcall DoToday(double &r);
	bool __fastcall DoFrac(double &Res, TokenType &n);
	bool __fastcall DoFact(double &Res, TokenType &n);
	bool __fastcall DoInt(double &Res, TokenType &n);
	bool __fastcall DoSin(double &Res, TokenType &n);
	bool __fastcall DoCos(double &Res, TokenType &n);
	bool __fastcall DoTan(double &res, TokenType &n);
	bool __fastcall DoCoTan(double &res, TokenType &n);
	bool __fastcall DoSinh(double &Res, TokenType &n);
	bool __fastcall DoCosh(double &Res, TokenType &n);
	bool __fastcall DoTanh(double &res, TokenType &n);
	bool __fastcall DoCoTanh(double &res, TokenType &n);
	bool __fastcall DoMonth(double &res, TokenType &n);
	bool __fastcall DoYear(double &res, TokenType &n);
	bool __fastcall DoDay(double &res, TokenType &n);
	bool __fastcall DoDayOfWeek(double &res, TokenType &n);
	bool __fastcall DoMinute(double &res, TokenType &n);
	bool __fastcall DoSecond(double &res, TokenType &n);
	bool __fastcall DoHour(double &res, TokenType &n);
	bool __fastcall DoExp(double &Res, TokenType &n);
	bool __fastcall DoLn(double &res, TokenType &n);
	bool __fastcall DoLog10(double &res, TokenType &n);
	bool __fastcall DoLog2(double &res, TokenType &n);
	bool __fastcall DoAbs(double &res, TokenType &n);
	bool __fastcall DoArcTan(double &res, TokenType &n);
	bool __fastcall DoArcCoTan(double &res, TokenType &n);
	bool __fastcall DoRound(double &res, TokenType &n);
	bool __fastcall DoTrunc(double &res, TokenType &n);
	bool __fastcall DoDegrees(double &res, TokenType &n);
	bool __fastcall DoRadians(double &res, TokenType &n);
	bool __fastcall DoRand(double &res, TokenType &n);
	bool __fastcall DoSqr(double &res, TokenType &n);
	bool __fastcall DoSqrt(double &res, TokenType &n);
	bool __fastcall DoArcSin(double &res, TokenType &n);
	bool __fastcall DoArcCos(double &res, TokenType &n);
	void __fastcall DoFunc(double &res, TokenType &n);
	void __fastcall Primitive(double &res, TokenType &n);
	double __fastcall Sign(double Number);
	void __fastcall Level6(double &res, TokenType &n);
	void __fastcall Level5(double &res, TokenType &n);
	void __fastcall Level4(double &res, TokenType &n);
	void __fastcall Level3(double &res, TokenType &n);
	void __fastcall Level2(double &res, TokenType &n);
	void __fastcall Level1(double &res, TokenType &n);
	double __fastcall GetExpr(bool &Valid);
	void __fastcall DoErr(TokenType &n);
	bool __fastcall IsCellVar(void);
	double __fastcall GetCellVar(void);
	double __fastcall GetCellVal(int col, int row);
	int __fastcall IsCellRangeFunc( System::AnsiString match);
	bool __fastcall SolveCellRangeFunc( System::AnsiString match, double &res, int func);
	
public:
	__fastcall TGridFormula(Grids::TStringGrid* grid);
	__property System::AnsiString Expression = {read=fExpression, write=fExpression, nodefault};
	__property int Row = {read=fRow, write=fRow, nodefault};
	__property int Col = {read=fCol, write=fCol, nodefault};
	__property int ErrorPosition = {read=fErrorPosition, write=fErrorPosition, nodefault};
	bool __fastcall Calc(double &r);
	
__published:
	__property TIsCustomFunction IsCustomFunction = {read=fIsCustomFunction, write=fIsCustomFunction};
	__property TCalcCustomFunction CalcCustomFunction = {read=fCalcCustomFunction, write=fCalcCustomFunction
		};
public:
	/* TObject.Destroy */ __fastcall virtual ~TGridFormula(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Parser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Parser;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Parser
